desc "Clean build tree (remove all object files)"
task :'clean' => :'clean:all'

namespace :'clean' do

  task :'all' => [ :'setup', :'pre', :'main', :'post' ]
  task :'pre'
  task :'post'

  task :'main' => [ :'stc' , 'librun' , :'packages' ]

  task :'stc' do
    chdir BUILD_DIR / 'stx' / 'stc' do
      make 'clean'
    end
  end

  task :'librun' do
    chdir BUILD_DIR / 'stx' / 'librun' do
      make 'clean'      
    end
  end

  task :'packages'

end

desc "Clobber build tree (remove all object files and .dll/executables)"
task :'clobber' => :'clobber:all'

namespace :'clobber' do

  task :'all' => [ :'setup', :'pre', :'main', :'post' ]
  task :'pre'
  task :'post'

  task :'main' => [ :'stc' , :'librun' , :'include', :'packages' ]

  task :'include' do
    rm_rf BUILD_DIR / 'stx' / 'include'  
  end

  task :'stc' do
    chdir BUILD_DIR / 'stx' / 'stc' do
      make 'clobber'
    end
  end

  task :'librun' do
    chdir BUILD_DIR / 'stx' / 'librun' do
      make 'clobber'      
    end
  end

  task :'packages'

end



# common tasks and helpers
task :'clean-clobber:setup-tasks' do
  project.packages_and_application.each do | pkg |
    pkg_wc = File.join(BUILD_DIR , pkg.directory)

    task :'clean:packages' => :"clean:package:#{pkg.name}"

    task :"clean:package:#{pkg.name}" do
      #if File.exist? pkg_wc then
        chdir pkg_wc do
          if unix?
            make 'clean' if File.exist('Makefile')
          end
          if win32?
            make 'clean' if File.exist("bmake.bat")
          end
        end
      #end
    end

    task :'clobber:packages' => :"clobber:package:#{pkg.name}"

    task :"clobber:package:#{pkg.name}" do
      #if File.exist? pkg_wc then
        chdir pkg_wc do
          if unix? && ( File.exist? 'Makefile' )
            make 'clobber'
          elsif win32? && ( File.exist? 'bc.mak' )
            make 'clobber'
          end
        end
      #end
    end
  end
end

task :'setup:tasks' => 'clean-clobber:setup-tasks'


